#include "machines.h"
#include "errors.h"
#include "linked_lib.h"

#include <iostream>
#include <stdlib.h>
#include <string>
#include <cmath>

using namespace std;

Node::Node(const string& n, IP_address ip)
        : local_ip_("?") // REPLACE THIS LINE BY YOUR INITIALIZATION CODE HERE
{}

Node::~Node() {}

void Node::format(ostream& os) const
{
    os << "    name = \"" << name_ << "\",\n    local_ip = " << local_ip_;
}

IP_address Node::get_ip() const
{
    // [YOUR HW6 Node::get_ip() CODE HERE]
}


Laptop::Laptop(const string& n, IP_address ip) : Node(n, ip)
{
    // [YOUR CODE HERE]
}

bool Laptop::can_connect(const shared_ptr<Node>& x) const
{
    // [YOUR CODE HERE]
}

void Laptop::connect(const shared_ptr<Node>& x)
{
    // [YOUR CODE HERE; similar to your HW6 Node::connect]
}

void Laptop::disconnect(const shared_ptr<Node>& x)
{
    // [YOUR CODE HERE; similar to your HW6 Node::disconnect]
}

size_t Laptop::send()
{
    // [YOUR CODE HERE]
}

void Laptop::receive(Datagram* d)
{
    // [PART OF YOUR HW7 receive CODE HERE]
}

void Laptop::allocate_datagram(const IP_address& dst,
                               const string& message)
{
    // [YOUR CODE HERE]
}

string Laptop::release_datagram()
{
    // [YOUR HW7 CODE HERE]
}

void Laptop::format(ostream& os) const
{
    os << "laptop {\n";
    Node::format(os);
    os << ",\n    incoming = ";
    if (incoming_) os << *incoming_;
    else           os << "nullptr";
    os << ",\n    outgoing = ";
    if (outgoing_) os << *outgoing_;
    else           os << "nullptr";
    os << ",\n    server = ";
    if (server_ != nullptr) os << server_->get_ip();
    else                    os << "nullptr";
    os << "\n  }";
}

Laptop::~Laptop()
{
    // [YOUR CODE HERE]
}


Server::Server(const string& n, IP_address a)
        : Node(n, a) // REPLACE THIS LINE BY YOUR INITIALIZATION CODE HERE
{}

bool Server::can_connect(const shared_ptr<Node>& x) const
{
    // [YOUR CODE HERE]
}

void Server::connect(const shared_ptr<Node>& x)
{
    // [YOUR CODE HERE; similar to your HW6 Node::connect]
}

void Server::disconnect(const shared_ptr<Node>& x)
{
    // [YOUR CODE HERE; similar to your HW6 Node::disconnect]
}

void Server::receive(Datagram* d)
{
    // [PART OF YOUR HW7 receive CODE HERE]
}

void Server::format(ostream& os) const
{
    os << "server {\n";
    Node::format(os);
    os << ",\n    node_list = [ ";
    for (auto& node : node_list_)
        os << node->get_ip() << ' ';
    os << "],\n    data_list = ";
    list_format(os, data_list_);
    os << "\n  }";
}

size_t Server::send()
{
    // [YOUR CODE HERE; similar to your HW7 Node::send, except for datagrams
    // sending to Laptop]
}

Server::~Server()
{
}


WAN_node::WAN_node(const string& n, IP_address a)
        : Node(n, a) // REPLACE THIS LINE BY YOUR INITIALIZATION CODE HERE
{}

bool WAN_node::can_connect(const shared_ptr<Node>& x) const
{
    // [YOUR CODE HERE]
}

void WAN_node::connect(const shared_ptr<Node>& x)
{
    // [YOUR CODE HERE; similar to your HW6 Node::connect]
}

void WAN_node::disconnect(const shared_ptr<Node>& x)
{
    // [YOUR CODE HERE; similar to your HW6 Node::disconnect]
}

void WAN_node::receive(Datagram* d)
{
    // [PART OF YOUR HW7 receive CODE HERE]
}


void WAN_node::format(ostream& os) const
{
    os << "WAN_node {\n";
    Node::format(os);
    os << ",\n    node_list = [ ";
    for (auto& node : node_list_)
        os << node->get_ip() << ' ';
    os << "],\n    data_list = ";
    list_format(os, data_list_);
    os << "\n  }";
}

size_t WAN_node::send()
{
    // [YOUR CODE HERE; similar to your HW7 Node::send]
}

WAN_node::~WAN_node()
{
}

std::ostream& operator<<(std::ostream& os, const Node& n)
{
    n.format(os);
    return os;
}
